<?php

namespace App\ViewModels\Setor\SetorRegistrationViewModel;
use App\Utils\Builder;
use App\Utils\ResponseException;
use Config\CustomRules;
use Exception;

class SetorRegistrationViewModelBuilder implements Builder
{
    private $descricao;
    private $id_centro_custo;
    private $criado_em;
    private $atualizado_em;
    private $desativado_em;
    private $criado_por;
    private $alterado_por;
    private $desativado_por;

    /**
     * @param mixed $id_centro_custo
     * @return SetorRegistrationViewModelBuilder
     */
    public function setIdCentroCusto($id_centro_custo)
    {
        $this->id_centro_custo = $id_centro_custo;
        return $this;
    }

    /**
     * @param mixed $descricao
     * @return SetorRegistrationViewModelBuilder
     */
    public function setDescricao($descricao)
    {
        $this->descricao = $descricao;
        return $this;
    }

    /**
     * @param mixed $criado_em
     * @return SetorRegistrationViewModelBuilder
     */
    public function setCriadoEm($criado_em)
    {
        $this->criado_em = $criado_em;
        return $this;
    }

    /**
     * @param mixed $atualizado_em
     * @return SetorRegistrationViewModelBuilder
     */
    public function setAtualizadoEm($atualizado_em)
    {
        $this->atualizado_em = $atualizado_em;
        return $this;
    }

    /**
     * @param mixed $desativado_em
     * @return SetorRegistrationViewModelBuilder
     */
    public function setDesativadoEm($desativado_em)
    {
        $this->desativado_em = $desativado_em;
        return $this;
    }

    /**
     * @param mixed $criado_por
     * @return SetorRegistrationViewModelBuilder
     */
    public function setCriadoPor($criado_por)
    {
        $this->criado_por = $criado_por;
        return $this;
    }

    /**
     * @param mixed $alterado_por
     * @return SetorRegistrationViewModelBuilder
     */
    public function setAlteradoPor($alterado_por)
    {
        $this->alterado_por = $alterado_por;
        return $this;
    }

    /**
     * @param mixed $desativado_por
     * @return SetorRegistrationViewModelBuilder
     */
    public function setDesativadoPor($desativado_por)
    {
        $this->desativado_por = $desativado_por;
        return $this;
    }


    public function build () {
        $paciente_registration_view_model = new SetorRegistrationViewModel();
        $paciente_registration_view_model->setDescricao($this->descricao);
        $paciente_registration_view_model->setIdCentroCusto($this->id_centro_custo);
        $paciente_registration_view_model->setCriadoEm($this->criado_em);
        $paciente_registration_view_model->setAtualizadoEm($this->atualizado_em);
        $paciente_registration_view_model->setDesativadoEm($this->desativado_em);
        $paciente_registration_view_model->setCriadoPor($this->criado_por);
        $paciente_registration_view_model->setAlteradoPor($this->alterado_por);
        $paciente_registration_view_model->setDesativadoPor($this->desativado_por);
        return $paciente_registration_view_model;
    }
}
